/* -*- Mode: C; c-basic-offset:4 ; -*- */
/*  $Id: gthread.c,v 1.3 2002/02/13 16:45:11 gropp Exp $
 *
 *  (C) 2001 by Argonne National Laboratory.
 *      See COPYRIGHT in top-level directory.
 */

#include "mpiimpl.h"

/* To simplify this file: rather than embed each possible thread library in 
   this single file, it should include a separate file for each thread type,
   such as pthread.c, winthread.c, etc., where these files implement the
   necessary thread functions.  This still needs to be done.

   If an include file is needed by other routines (e.g., it is needed by 
   mpiimpl.h), it should be copied to the src/include directory by the 
   top-level configure.
*/
/* General thread support */
#if defined(HAVE_PTHREAD_CREATE)
pthread_key_t MPID_GetThreadKey( void )
{
    pthread_key_t key;
    pthread_key_create( &key, 0 );
    return key;
}

pthread_t MPID_GetThreadId( void )
{
    return pthread_self();
}
#elif defined(HAVE_THR_CREATE)
#endif
